import { Map, Symbol } from 'typescript';
import { ExportDoc } from './ExportDoc';
import { MemberDoc } from './MemberDoc';
/**
 * This document represents things that contain members such as classes, enums and interfaces.
 *
 * Although such things can have multiple mergeable declarations, we consider them as a single doc.
 * So such documents are not OverloadableExport docs.
 */
export declare abstract class ContainerExportDoc extends ExportDoc {
    members: MemberDoc[];
    protected getMemberDocs(members: Map<Symbol>, hidePrivateMembers: boolean, isStatic: boolean): MemberDoc[];
}
