"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var getParameters_1 = require("../services/TsParser/getParameters");
var getTypeParametersText_1 = require("../services/TsParser/getTypeParametersText");
var encodeAnchor_1 = require("../utils/encodeAnchor");
var MemberDoc_1 = require("./MemberDoc");
var MethodMemberDoc = (function (_super) {
    __extends(MethodMemberDoc, _super);
    function MethodMemberDoc(containerDoc, symbol, declaration, basePath, namespacesToInclude, isStatic, overloads) {
        if (overloads === void 0) { overloads = []; }
        var _this = _super.call(this, containerDoc, symbol, declaration, basePath, namespacesToInclude, isStatic) || this;
        _this.overloads = overloads;
        _this.parameters = getParameters_1.getParameters(_this.declaration, _this.namespacesToInclude);
        _this.name = _this.computeName();
        _this.anchor = _this.computeAnchor();
        _this.id = _this.containerDoc.id + "." + _this.anchor + ")";
        _this.aliases = _this.computeAliases();
        _this.typeParameters = getTypeParametersText_1.getTypeParametersText(_this.declaration, _this.namespacesToInclude);
        return _this;
    }
    MethodMemberDoc.prototype.computeName = function () {
        return this.symbol.name === '__new' ? 'new ' :
            this.symbol.name === '__constructor' ? 'constructor' :
                this.symbol.name === '__call' ? '' :
                    this.symbol.name;
    };
    MethodMemberDoc.prototype.computeAnchor = function () {
        // if the member is a "call" type then it has no name
        var anchorName = this.name.trim() || 'call';
        // if there is more than one declaration then we need to include the param list to distinguish them
        return encodeAnchor_1.encodeAnchor(this.symbol.getDeclarations().length === 1 ? anchorName : anchorName + "(" + this.parameters.join(', ') + ")");
    };
    MethodMemberDoc.prototype.computeAliases = function () {
        var _this = this;
        var aliases = [];
        this.containerDoc.aliases.forEach(function (alias) {
            aliases.push(alias + "." + _this.anchor);
        });
        return aliases;
    };
    return MethodMemberDoc;
}(MemberDoc_1.MemberDoc));
exports.MethodMemberDoc = MethodMemberDoc;
//# sourceMappingURL=MethodMemberDoc.js.map