import { Declaration } from 'typescript';
import { ModuleSymbol } from '../services/TsParser';
import { FileInfo } from '../services/TsParser/FileInfo';
import { ApiDoc } from './ApiDoc';
import { ExportDoc } from './ExportDoc';
/**
 * A module doc represents an ES6 module that contains exports such as classes, functions, constants, etc,
 * which are represented by docs of their own.
 */
export declare class ModuleDoc implements ApiDoc {
    symbol: ModuleSymbol;
    private basePath;
    docType: string;
    id: string;
    name: string;
    declaration: Declaration;
    aliases: string[];
    exports: ExportDoc[];
    fileInfo: FileInfo;
    startingLine: number;
    endingLine: number;
    path: string;
    outputPath: string;
    content: string;
    constructor(symbol: ModuleSymbol, basePath: string);
}
