import { Declaration, TypeChecker } from 'typescript';
import { ExportDoc } from './ExportDoc';
import { FunctionExportDoc } from './FunctionExportDoc';
/**
 * This represents a single overload of an exported function.
 * There will be a FunctionExportDoc that contains these overloads
 */
export declare class OverloadInfo extends ExportDoc {
    functionDoc: FunctionExportDoc;
    docType: string;
    parameters: string[];
    type: string;
    constructor(functionDoc: FunctionExportDoc, declaration: Declaration, typeChecker: TypeChecker);
}
