import { DocCollection, Processor } from 'dgeni';
import { Symbol } from 'typescript';
import { TsParser } from '../../services/TsParser';
import { ExportDoc } from '../../api-doc-types/ExportDoc';
import { SourcePattern } from './SourcePattern';
export declare function readTypeScriptModules(tsParser: TsParser, modules: any, namespacesToInclude: string[], exportSymbolsToDocsMap: Map<Symbol, ExportDoc>, createDocMessage: any, log: any): ReadTypeScriptModules;
export declare class ReadTypeScriptModules implements Processor {
    private tsParser;
    private modules;
    private namespacesToInclude;
    private exportSymbolsToDocsMap;
    private createDocMessage;
    private log;
    $runAfter: string[];
    $runBefore: string[];
    $validate: {
        basePath: {
            presence: boolean;
        };
        hidePrivateMembers: {
            inclusion: boolean[];
        };
        ignoreExportsMatching: {};
        sortClassMembers: {
            inclusion: boolean[];
        };
        sourceFiles: {
            presence: boolean;
        };
    };
    sourceFiles: Array<SourcePattern | string>;
    basePath: string;
    hidePrivateMembers: boolean;
    sortClassMembers: boolean;
    ignoreExportsMatching: Array<string | RegExp>;
    ignoreExportsRegexes: RegExp[];
    constructor(tsParser: TsParser, modules: any, namespacesToInclude: string[], exportSymbolsToDocsMap: Map<Symbol, ExportDoc>, createDocMessage: any, log: any);
    $process(docs: DocCollection): void;
    private addModuleDocs(docs, moduleSymbols, basePath);
    private addExportDocs(docs, moduleDoc, typeChecker);
    private addExportDoc(docs, moduleDoc, exportDoc);
    private addMemberDocs(docs, members);
}
