"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var typescript_1 = require("typescript");
var getTypeText_1 = require("./getTypeText");
function getDeclarationTypeText(declaration, namespacesToInclude) {
    // if the declaration has an explicit type then use that
    var type = getType(declaration);
    if (type)
        return getTypeText_1.getTypeText(type, namespacesToInclude);
    // if the declaration is a type parameter then just use its textual value
    if (declaration.kind === typescript_1.SyntaxKind.TypeParameter) {
        return declaration.getText();
    }
    // if the declaration is being initialized then use the initialization value
    return getInitializerText(declaration);
}
exports.getDeclarationTypeText = getDeclarationTypeText;
function getType(declaration) {
    return declaration.type;
}
function getInitializerText(declaration) {
    var initializer = declaration.initializer;
    return initializer ? initializer.getText() : '';
}
exports.getInitializerText = getInitializerText;
//# sourceMappingURL=getDeclarationTypeText.js.map