"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var typescript_1 = require("typescript");
function getHeritageClause(declaration) {
    var heritageString = '';
    if (declaration.heritageClauses) {
        declaration.heritageClauses.forEach(function (heritage) {
            if (heritage.token === typescript_1.SyntaxKind.ExtendsKeyword)
                heritageString += ' extends';
            if (heritage.token === typescript_1.SyntaxKind.ImplementsKeyword)
                heritageString += ' implements';
            heritageString += heritage.types.map(function (typ) { return typ.getFullText(); }).join(',');
        });
    }
    return heritageString;
}
exports.getHeritageClause = getHeritageClause;
//# sourceMappingURL=getHeritageClause.js.map