"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
var getParameters_1 = require("./getParameters");
var path = require('canonical-path');
describe('getParameters', function () {
    var parser;
    var basePath;
    beforeEach(function () {
        parser = new _1.TsParser(require('dgeni/lib/mocks/log')(false));
        basePath = path.resolve(__dirname, '../../mocks');
    });
    it('should return the parameters of the function', function () {
        var parseInfo = parser.parse(['tsParser/getParameters.test.ts'], basePath);
        var moduleExports = parseInfo.moduleSymbols[0].exportArray;
        var params = getParameters_1.getParameters(moduleExports[0].getDeclarations()[0], []);
        expect(params).toEqual([
            'a: string',
            'b: () => number',
            'c?: Date',
            'd = 45',
            'e: string = \'moo\'',
            '...args: string[]',
        ]);
    });
});
//# sourceMappingURL=getParameters.spec.js.map